<template>
  <form
    class="p-2 flex flex-col justify-center gap-4"
    @submit.prevent.stop="createProject"
  >
    <div class="flex flex-row justify-between gap-2 items-center">
      <label for="name">Nome:</label>
      <BaseInput
        id="name"
        v-model="name"
        placeholder="Nome sobrenome"
        required
        class="w-52"
      />
    </div>
    <div class="flex flex-row justify-between gap-2 items-center">
      <label for="email">E-mail:</label>
      <BaseInput
        id="email"
        v-model="email"
        placeholder="email@email.com.br"
        required
        class="w-52"
        type="email"
      />
    </div>
    <div class="flex flex-row justify-between gap-2 items-center">
      <label for="firstPassword">Senha:</label>
      <BaseInput
        id="firstPassword"
        v-model="firstPassword"
        placeholder="*************"
        required
        class="w-52"
        type="password"
      />
    </div>
    <div class="flex flex-row justify-between gap-2 items-center">
      <label for="secondPassword">Repita senha:</label>
      <BaseInput
        id="secondPassword"
        v-model="secondPassword"
        placeholder="*************"
        required
        class="w-52"
        type="password"
      />
    </div>
    <div class="flex flex-row justify-between gap-2 items-center">
      <label for="authorizationId">Cargo:</label>
      <BaseSelectInput
        id="authorizationId"
        v-model="authorizationId"
        required
        class="w-52"
        :data="authorizations"
      />
    </div>
    <div class="flex flex-row justify-center">
      <BaseButton
        type="submit"
        label="Cadastrar"
        class="border border-success-300 border-opacity-40 rounded bg-success-300 bg-opacity-20"
      >
        <PlusIcon class="h-5 w-5" />
      </BaseButton>
    </div>
  </form>
</template>

<script>
import { PlusIcon } from '@vue-hero-icons/outline'
import BaseInput from '../ui/BaseInput.vue'
import BaseButton from '../ui/BaseButton.vue'
import BaseSelectInput from '../ui/BaseSelectInput.vue'
import { getAxiosHeaders } from '~/utils/utils'
export default {
  name: 'CreateProject',
  components: {
    BaseSelectInput,
    BaseButton,
    BaseInput,
    PlusIcon,
  },
  data() {
    return {
      name: null,
      email: null,
      firstPassword: null,
      secondPassword: null,
      authorizationId: null,
    }
  },
  computed: {
    authorizations() {
      return this.$store.state.authorizations.list
    },
  },
  methods: {
    async createProject() {
      if (this.firstPassword !== this.secondPassword) {
        return this.$toast.info('Senhas não coincidem.', {
          closeOnSwipe: true,
          duration: 3000,
        })
      }
      try {
        await this.$axios
          .$post(
            'addNewUser',
            {
              name: this.name,
              email: this.email,
              password: this.firstPassword,
              authorization_id: this.authorizationId,
            },
            getAxiosHeaders(this.$auth)
          )
          .then((response) => {
            if (response.status.is_error) {
              return this.$toast.error(
                'Ocorreu um erro ao cadastrar usuário',
                {
                  closeOnSwipe: true,
                  duration: 3000,
                }
              )
            }
            /* Precisa ser refatorado ao adicionar store/visualização 
            de usuarios cadastrados, no momento não existe reatividade */
            this.$toast.success(
              `Usuário ${response.data.user.name} cadastrado com sucesso!`,
              {
                closeOnSwipe: true,
                duration: 2000,
              }
            )
            this.$emit('close')
          })
      } catch (error) {
        // eslint-disable-next-line no-console
        console.warn(error)
        this.$toast.error('Ocorreu um erro inesperado...', {
          closeOnSwipe: true,
          duration: 2000,
        })
      }
    },
  },
}
</script>
